(* Ten modul zawiera rozne podstawowe funkcje i definicje, ktore nie   *)
(* pasowaly do innych modulow i sa za male, by tworzyc dla nich osobny *)
(* modul. *)

val min2: real -> real -> real;
val max2: real -> real -> real;
val min3: real -> real -> real -> real;
val max3: real -> real -> real -> real;

axiom Forall(x,y) => (min2 x y = (if x<y then x else y));
axiom Forall(x,y) => (max2 x y = (if x>y then x else y));
axiom Forall(x,y,z) => (min3 x y z = min2 x (min2 y z));
axiom Forall(x,y,z) => (max3 x y z = max2 x (max2 y z));

(* intriangle (x1,y1,x2,y2,x3,y3,xp,yp) : czy (xp,yp) jest w trojkacie *)
(* wyznaczonym przez pozostale punkty (na brzegu nieokreslone)         *)

val intriangle : (real*real * real*real * real*real * real*real) -> bool;

(* konwersje *)
val itr : int -> real;
val rts: real -> string;

(* kwadrat *)
val square: real -> real;

(* predefiniowane funkcje okresowe *)
val periodic: string -> ((real -> real) option);

axiom Forall s => (case periodic s of
  NONE => true
| SOME f => Forall x => f(x) = f(x+1.0) andalso f(x)=f(0.0-x));
