(* Ten modul zawiera rozne podstawowe funkcje i definicje, ktore nie   *)
(* pasowaly do innych modulow i sa za male, by tworzyc dla nich osobny *)
(* modul. *)

(* minmimum i maksimum z dwoch lub trzech liczb *)
fun min2 x y:real = if x<y then x else y;
fun min3 x y z = min2 (min2 x y) z;
fun max2 x y:real = if x>y then x else y;
fun max3 x y z = max2 (max2 x y) z;

(* czy (xp,yp) jest w trojkacie wyznaczonym przez pozostale punkty *)
(* (na brzegu nieokreslone)                                        *)
fun intriangle (x1,y1,x2,y2,x3,y3,xp,yp) = let

  (* czy trzy podane warunki sa rownowazne *)
  fun equivalent3 true true true = true
    | equivalent3 false false false = true
    | equivalent3 b1 b2 b3 = false;
  
  axiom Forall b => equivalent3 b b b;

  axiom Forall (b,c,d) =>
    b<>c orelse c<>d orelse d<>b implies not (equivalent3 b c d);

  fun test (x1,y1,x2,y2,x3,y3) =
    (x2-x1)*(y3-y1)-(x3-x1)*(y2-y1) > 0.0

  in equivalent3
    (test (x1,y1,x2,y2,xp,yp))
    (test (x2,y2,x3,y3,xp,yp))
    (test (x3,y3,x1,y1,xp,yp))
  end;

(* zamien liczbe calkowita na rzeczywista *)
fun itr x = Real.fromInt x;

(* zamien liczbe rzeczywista na string *)
fun rts x = Real.toString x;

fun square x:real = x*x;

local
fun frac x = (x-Real.fromInt(Real.floor x))
fun pisc x = (2.0*Math.pi*x)
fun ctp  x = (x+1.0)/2.0
fun abs     x = if x<0.0 then ~x else x;
fun posit   x = if x<0.0 then 0.0 else x;
fun gsqrt   x = if x<0.0 then 0.0 else Math.sqrt(x);

fun bow     x = if x<1.0 then x else
                if x<3.0 then 1.0 else
                if x<4.0 then 4.0-x else 0.0;

fun fcos     x = ctp(Math.cos(pisc x))
fun fteeth   x = abs(1.0-2.0*frac x);
fun fbow     x = bow(frac(x+0.333333)*6.0);
fun fdash1   x = if fteeth x>0.9 then 1.0 else 0.0
fun fdash5   x = if fteeth x>0.5 then 1.0 else 0.0
fun fdash9   x = if fteeth x>0.1 then 1.0 else 0.0
fun fteeth2  x = posit(fteeth x*2.0-1.0);
fun fteeth4  x = posit(fteeth x*4.0-3.0);
fun fsteeth  x = fteeth x * fteeth x;
fun fsteeth2 x = fteeth2 x * fteeth2 x;
fun fsteeth4 x = fteeth4 x * fteeth4 x;
fun fscos    x = fcos x * fcos x;
fun fpipe1   x = let val y = 1.0-fteeth x in gsqrt(1.0- 1.0*y*y) end;
fun fpipe2   x = let val y = 1.0-fteeth x in gsqrt(1.0- 4.0*y*y) end;
fun fpipe3   x = let val y = 1.0-fteeth x in gsqrt(1.0- 9.0*y*y) end;
fun fpipe4   x = let val y = 1.0-fteeth x in gsqrt(1.0-16.0*y*y) end;

in
  fun periodic "fcos"     = SOME(fcos)
    | periodic "fteeth"   = SOME(fteeth)
    | periodic "fbow"     = SOME(fbow)
    | periodic "fdash1"   = SOME(fdash1)
    | periodic "fdash5"   = SOME(fdash5)
    | periodic "fdash9"   = SOME(fdash9)
    | periodic "fteeth2"  = SOME(fteeth2)
    | periodic "fteeth4"  = SOME(fteeth4)
    | periodic "fsteeth"  = SOME(fsteeth)
    | periodic "fsteeth2" = SOME(fsteeth2)
    | periodic "fsteeth4" = SOME(fsteeth4)
    | periodic "fscos"    = SOME(fscos)
    | periodic "fpipe1"   = SOME(fpipe1)
    | periodic "fpipe2"   = SOME(fpipe2)
    | periodic "fpipe3"   = SOME(fpipe3)
    | periodic "fpipe4"   = SOME(fpipe4)
    | periodic _          = NONE
end;
