{
open Grammar;

(* zamiana slowa kluczowego na token *)

fun keyword s =
     case s of
         "sin"          => TFSIN
       | "cos"          => TFCOS
       | "exp"          => TFEXP
       | "sgn"          => TFSGN
       | "atan"         => TFATAN
       | "ln"           => TFLN
       | "rtp"          => TFRTP
       | "ctp"          => TFCTP
       | "max"          => TFFMAX
       | "min"          => TFFMIN
       | "abs"          => TFABS
       | "sqrt"         => TFSQRT
       | "red"          => TFRED
       | "green"        => TFGREEN
       | "blue"         => TFBLUE
       | "num"          => TFNUM
       
       | "pi"           => TCPI
       | "e"            => TCE
       
       | "size"         => TISIZE
       | "bg"           => TIBG
       | "clear"        => TICLEARF
       | "add"          => TISURF
       | "surf"         => TISURF
       | "curve"        => TICURVE
       | "point"        => TIPOINT
       | "merge"        => TIMERGE
       | "save"         => TISAVE
       | "load"         => TILOAD
       | "view"         => TIVIEW
       | "quit"         => TIQUIT
       | "if"           => TIIF
       | "then"         => TIDO
       | "do"           => TIDO
       | "else"         => TIELSE
       | "while"        => TIWHILE
       | "include"      => TIINCLUDE
       | "info"         => TIINFO
       | "rot0"         => TIROTZERO
       | "rotxy"        => TIROTXY
       | "rotyz"        => TIROTYZ
       | "rotzx"        => TIROTZX
       | "geo"          => TIGEO
       | "interactive"  => TIINTERACTIVE
       | "diff"         => TIDIFF

       | "draw"         => TIDRAW
       | "sv"           => TISV
       | "dsv"          => TIDSV
       | "all"          => TIALL

       | "help"         => TIHELP
       
       | _              => case periodic s of 
         SOME f => TFANY f | NONE => TVAR s

}

rule Token = parse
   [`{`][^`}`]*[`}`]          { Token lexbuf }
 | [`#`][^`\n`]*              { Token lexbuf }
 | [` ` `\t` `\n` `\r`]	      { Token lexbuf } 
 | [`0`-`9`]+`.`[`0`-`9`]+    { TNUM (getLexeme lexbuf)}
 | [`0`-`9`]+                 { TNUM (getLexeme lexbuf)}
 | `*`                        { TTIMES }
 | `+`                        { TPLUS }
 | `/`                        { TDIV }
 | `-`                        { TMINUS }
 | `(`                        { TLPAREN }
 | `)`                        { TRPAREN }
 | `[`                        { TLBRACK }
 | `]`                        { TRBRACK }
 | `,`                        { TCOMMA }
 | `;`                        { TSEMI }
 | ":="                       { TASSIGN }
 | `=`                        { TEQUAL }
 | `?`                        { TQMARK }
 | [`a`-`z``A`-`Z`][`a`-`z``A`-`Z``0`-`9`]* { keyword (getLexeme lexbuf) }
 | [`a`-`z``A`-`Z`][`a`-`z``A`-`Z``0`-`9`]*`.`[`a`-`z``A`-`Z``0`-`9`]* { TFNAME (getLexeme lexbuf) }
 | `$`                        { EOF }
 | eof                        { EOF }
 | _                          { raise Fail "illegal symbol"}
;
